#ifndef __SCREENQUADSceneNode_HPP
#define __SCREENQUADSceneNode_HPP

// Based on "CBaseFilter" by ItIsFree.
// Original thread: http://irrlicht.sourceforge.net/phpBB2/viewtopic.php?t=9857

#include <irrlicht.h>



class CScreenQuadSceneNode : public irr::scene::ISceneNode
{
    irr::core::aabbox3df aabb;               //An axis aligned bounding box. Actually not needed.
    irr::video::SMaterial material;            //The material used to render the Scene Node
    irr::video::S3DVertex2TCoords vertices[4];    //The vertices of the Scene Node.
                                    //Normally we wouldn't need more
                                    //than one set of UV coordinates.
                                    //But if we are to use the builtin materials, this is necesary

public:
    CScreenQuadSceneNode(irr::scene::ISceneNode* parent, irr::scene::ISceneManager* mgr, irr::s32 id);
    ~CScreenQuadSceneNode();

    const irr::core::aabbox3df& getBoundingBox() const
    {
        return aabb;
    }

    void OnRegisterSceneNode()
    {
     //This method is empty because it is best for us to render this scene node manually.
     //So, it is never really rendered on its own, if we don't tell it to do so.
    }

    void ChangeMaterialType(irr::video::E_MATERIAL_TYPE NewMat)
    {
        material.MaterialType= NewMat;
    }


    void render();

    irr::u32 getMaterialCount()
    {
        return 1;   //There is only one material
    }

    irr::video::SMaterial&getMaterial(irr::u32 i)
    {
        return material;//We always return the same material, so there is no need for more.
    }
};

#endif
