/** \file config.h
 *  \brief Defines all default values ( that is starting with an underscore "_" )
**/
#ifndef __BC_DEFINITION_HPP__
#define __BC_DEFINITION_HPP__

#include <boost/shared_ptr.hpp>
#include <boost/scoped_ptr.hpp>
#include <irrlicht.h>
#include "CustomEvent.hpp"
#include <list>




class CGameEngine;
class CPlayer;

namespace fus {
    class CLuaVM;
}

typedef CGameEngine* TEnginePtr;


typedef boost::shared_ptr<CPlayer> TPlayerPtr;


typedef fus::CLuaVM TScriptingVM;
typedef irr::core::vector3df TVector3df;
typedef irr::u32 TTimeUnit;


namespace EEntityType
{
// !!! Les int ne doivent pas se recouvrir !!
//enum class EEntityType  {
enum EId
{
//Enemy = 0,
//EnemyBullet = 1,
//EnemyMissile = 2,
//AlliedBullet = 4,
//AlliedMissile = 8,
//Player = 16,

Missile,
Bullet,
Battery,
Player,
Count
};

}

namespace NWalkyrieModes
{

//createAndConfigureStaticBattery
    enum ERealMode
    {
    //HighSpeedFighter = 0,
    yf19_Fighter = 0,
    yf19_Gerwalk,
    yf19_Battloid,

    yf21_Fighter,
    yf21_Gerwalk,
    yf21_Battloid,
    //FighterWithWheels =4  // Pareil que Efighter mais apres
    Count // internal use
    };


}

    enum class EWalkyrieMode : int
    {
    Fighter,
    Gerwalk,
    Battloid

    };

//typedef NWalkyrieModes::ERealMode TModeId;

class CStaticBattery;
typedef std::list<CStaticBattery*> TTrackedBatteries;






// TODO repasser en enum
namespace NPlayerInput
{

enum EId
//enum class NPlayerInput : int
{
MoveLeft = 0,   // Should remain first
//MoveLeftQuick,
MoveRight,
//MoveRightQuick,
MoveForward,
MoveBackward,
MainShoot,
//SwitchingDirection,
//EnableSpin,
//QuickMainShoot,
SecondShoot,
//QuickSecondShoot,
ModeUp,
ModeDown,

Count  // should remain last
};


typedef std::pair<NPlayerInput::EId, int> TBindId;

}


extern const wchar_t*  BindNames[(int)NPlayerInput::Count];
#define ENGINE  CGameEngine::getInstance()

#endif
