/**
\file transforming.hpp
\brief
todo le rendre transformable

*/
#ifndef IMULTIMODETRANSFORMER_HPP
#define IMULTIMODETRANSFORMER_HPP

//#include "IEntity.hpp"
#include <map>
#include <list>
#include <fusion/macros.hpp>
#include <fusion/fusion.hpp>
#include <array>
#include <irrlicht.h>
#include <vector>
#include <fusion/logging/ILogger.hpp>
//#include "SModeDescription.hpp"
#include "ITransformer.hpp"
#include "../def.hpp"
#include <type_traits>




/**

en gros g un tableau qui contient tous mes modes avec chacun un ID


Dans cette classe IMultiModeTransformer, j'enregistre juste les ID


**/



//,class MODE
// passer en parametre les noms des differents boosters, du mesh, ces caracteristiques
//EWalkyrieMode
template<typename __ID>
class IMultiModeTransformer :
    public ITransformer
{

public:
//    typedef MODE TMode;
    typedef __ID TModeId;

private:
    bool _cyclic;       //!< Set to true to be able to go from last to first mode



//    TModeId _currentMode;   //!<
//    TModeId _targetedMode;  //!<

    //!
    std::size_t _currentMode;   //!<
    std::size_t _targetedMode;  //!<


    typedef std::vector<TModeId> TCurrentModes;
    // Enregistre les id des modes qu'on peut utiliser
    TCurrentModes _activeSpecs;


// TODO remplacer par des std::size_t

public:
    bool transformInto(const TModeId& modeId)
//    IMultiModeTransformer::transformInto(const TModeId& modeId)
    {
        //BOOST_ASSERT( index > 0 && index < _availablesModes.size() );


        const int noFrame = getFrameFromModeId(modeId);


        if( targetFrame( noFrame ) )
        {

            _INFO << "Targetting mode [" << "" << "] -- Frame [" << noFrame << "]" ;// << *targetedMode;
//            _targetedMode = modeId;
            return true;
        }
        else
        {


        }



        return false;


    }


    /** \brief
     *
     * \param
     * \param
     * \return
     *
     */
    IMultiModeTransformer() :
        ITransformer(),
        _cyclic(false),
        _currentMode(0),
        _targetedMode(0)
    {
        static_assert( std::is_enum<__ID>::value == true , "Id should be an enum (just a test to remove)" );
        //clearModes();
        //forceMode(enforcedMode);
    //    this->load(node,id);
    }


    virtual ~IMultiModeTransformer()
    {
        //!
    }


    __ID getCurrentMode() const
    {
        return _activeSpecs[ _currentMode ];
    }

    __ID getTargetedMode() const
    {
        return _activeSpecs[ _targetedMode ];
    }

    /**
    **/
    void load(irr::scene::IAnimatedMeshSceneNode* node,const __ID& modeId)
    {
    //enforcedMode
        ITransformer::load(node);

        //forceMode(id);
        getNode()->setAnimationEndCallback(this);


        // -- clear modes
        clearModes(modeId);
    }

    void OnAnimationEnd(irr::scene::IAnimatedMeshSceneNode* node)
    {

        //
        ITransformer::OnAnimationEnd(node);

        //forceMode( static_cast<NWalkyrieModes::EId>(_targetedMode) );

        //_LOG_DEBUG
        //setFrameLoop
        //setLoopMode

        //interpolate(1.f ,  getModeFromModeId(_currentMode) , getModeFromModeId(_targetedMode) );
//        interpolate( 1.f, getModeFromModeId(_activeSpecs[_currentMode]), getModeFromModeId(_activeSpecs[_targetedMode]) );
        _currentMode = _targetedMode;

//        printMode();
        _INFO << "IMultiMode transformation finished. Current mode [" << _currentMode << "]";
        //onTransformationEnd();
        //_INFO << "End of Transformation" ;
    }



    /** \brief
     *
     * \param
     * \param
     * \return
     * Passer l'id dans lequel il va arriver
     */
    __ID getNextMode()
    {

        int targetedMode = _currentMode + 1;
    //boost::next();
    //boost::prior();

        if( targetedMode >= _activeSpecs.size() )
        {
            if(isCyclic())
            {
                targetedMode = 0;
            }
            else {
                targetedMode = _currentMode ;
            }
        }

        return _activeSpecs[targetedMode];

//        return transformInto( _activeSpecs[targetedMode]);
    }




    __ID getPreviousMode()
    {

        int targetedMode = _currentMode - 1;

        if(targetedMode < 0 )
        {

            if( isCyclic() )
            {
                targetedMode = _activeSpecs.size() - 1;
            }
            else
            {
//                return false;
                targetedMode = _currentMode;
            }
        }
//return false;
        return _activeSpecs[targetedMode];
//        return transformInto( _activeSpecs[targetedMode] );
    }




    // ??

    __ID getLastMode() const
    {
        //
        return _activeSpecs.back();
//        transformInto(  );
    }


    __ID getFirstMode() const
    {
        return _activeSpecs.front() ;
    }


    void enableCyclicTransformation(const bool& enable)
    {
        _cyclic = enable;
    }

    const bool& isCyclic() const { return _cyclic; }


    void forceMode(const TModeId& modeId)
    {
//        _INFO << "Enforcing mode [" << mode << "] !!";
//        const SModeDescription& mode = getModeFromModeId(modeId);
        const int frame = getFrameFromModeId(modeId);
//        getNode()->setCurrentFrame ( mode.getFrame() );
        targetFrame(frame);

//        interpolate(1.f , *this, mode);
//        _transforming = false;
    }



    /** \brief
     *
     * \param
     * \param
     * \return
     *
     */
//    void update();

    // TODO
    virtual int getFrameFromModeId(const __ID&) = 0;

    // todo passer en static
//    static SModeDescription& getModeFromModeId(const TModeId&);

    void clearModes( const __ID& id )
    {

        _activeSpecs.clear();
        _activeSpecs.push_back( id );

        //allowMode(id);
        forceMode(id);
    }

//    getAvailableModes()

    // TODO renommer en addMode
    // insertMode ?
    bool allowModes(const TModeId& modeId)
    {
        //! TODO BOOST_ASSERT ?

        // check frame is ok
//        int noFrame = getFrameFromModeId(modeId);
//
//        //mode.getFrame()
//        if( noFrame > _animatedNode->getMesh()->getFrameCount() )
//        {
//            _LOG_WARNING << "mode frame > end frame of node";
//        }


        _LOG_DEBUG << "Mode [" << "] allowed ";
        _activeSpecs.push_back(  modeId );
        //return *this;
        return true;
    }

};


//#include "transforming.inl"

#endif
