#include "IFleetForwardListBased.hpp"
#include "../game_engine.hpp"
#include "../states/IPlayableState.hpp"
#include "../entities/player.hpp"
//#include "CGraphicalLevel.hpp"
//#include "states/CSinglePlayerState.hpp"
#include <fusion/logging/Logger.hpp>
#include <fusion/maths/macros.hpp>
#include <iostream>
#include "../fx/CParticleManager.hpp"
#include "../entities/CBullet.hpp"
#include "../entities/CStaticBattery.hpp"
#include "../entities/CMissile.hpp"
#include "../audio/ISound.hpp"
#include <functional>

using namespace irr;


IFleetForwardListBased::TDeadPool IFleetForwardListBased::_deadPool;


#define LOOP_THROUGH_BATTERIES(func) _activeBatteries.remove_if( std::bind1st( std::mem_fun( func ),this) );


//CSinglePlayerState* state
//IFleetForwardListBased::IFleetForwardListBased(audio::ISoundManager* soundMgr) :
IFleetForwardListBased::IFleetForwardListBased(IPlayableState* state) :
//    _soundMgr(soundMgr)
    IFleet(state)
{
    //ctor
}



IFleetForwardListBased::~IFleetForwardListBased()
{
    //dtor

}



irr::scene::ISceneNode *
IFleetForwardListBased::getCachedFleetNode()  {
    return getPlayState()->_cachedFleetNode;
};

irr::scene::ISceneNode *
IFleetForwardListBased::getActiveFleetNode()  {
    return getPlayState()->_activeFleetNode;
};


std::size_t
IFleetForwardListBased::getNumberOfCachedEntities(const EEntityType::EId& type) const
{
    //
    return std::distance( std::begin(_deadPool[ type ]), std::end(_deadPool[ type ])  );
}

void
IFleetForwardListBased::registerActiveBattery(IStaticBattery* battery)
{

//    battery->_next = _root;
//    _root = battery;

    //_aliveBatteries.push_front( battery );
    battery->setFleet(this);
    // TODO
//    battery->_node->setParent( getActiveFleetNode() );
    battery->_damageInflictedOnCollision = 0;

    getPlayState()->onBatteryActivation( battery );

    _activeBatteries.push_front( battery );
}



IStaticBattery*
IFleetForwardListBased::getDeadButAllocatedBattery(const EEntityType::EId& type)
{

    IStaticBattery* battery = nullptr;

  //  #error not existing
    if( !_deadPool[type].empty() )
    {

        battery = _deadPool[type].front();
        _deadPool[type].pop_front();
    }
    else
    {

        FUS_ASSERT( _state != 0 && "IFleet should have a playable state to refer to");
        // HACK while game is singleton
        scene::IAnimatedMeshSceneNode*    node = _state->addAnimatedNode();

//        node = smgr->addAnimatedMeshSceneNode( 0,  // fleet
//                                            0,   // parent
//                                            -1, //id
//                                            core::vector3df(0, 0, 0),   //position
//                                            core::vector3df(0, 0, 0), //rotation
//                                            core::vector3df(1.0f, 1.0f, 1.0f), // scale
//                                            true        // add node even without mesh
//                                            );


//        _INFO << "creating from scratch";
        switch(type)
        {

            case EEntityType::Bullet:
                battery = new CBullet();
                break;

            case EEntityType::Battery:
                battery = new CStaticBattery();
                break;

            case EEntityType::Missile:
                battery = new CMissile();
                break;

            default:
                break;
        }


        //
        battery->_node = node;

    }

    FUS_ASSERT( battery != nullptr);



    return battery;
}



// Do not use in production mode since might slow down
std::size_t
IFleetForwardListBased::getNumberOfActiveEntities() const
{
    //! TODO
    return std::distance( _activeBatteries.begin(), _activeBatteries.end() );
}


// get nearest missile
IStaticBattery*
IFleetForwardListBased::getNearestEnemy(const TVector3df& position)
{


    auto nextBattery(_activeBatteries.begin()), last( _activeBatteries.end() );
    IStaticBattery* current = 0;

//    std::for_each(std::begin(arr), std::end(arr), [](){}
    //_INFO << "START \r\n";
    while( nextBattery != last )
    {

        nextBattery++;
//        current = nextBattery;
//        nextBattery = current->_next;

    }
//    while(j != j_end){
//
//        if(j->getPosition().getDistanceFromSQ( position) < nearestMissile->getPosition().getDistanceFromSQ( position)){
//            nearestMissile = j;
//        }
//        ++j;
//    }
//    return &(*nearestMissile);
    return 0;
}



IStaticBattery*
IFleetForwardListBased::getNextTarget(const std::list<IStaticBattery*>& trackedBatteries)
{


    //auto

    /*CStaticBattery *nextBattery = _activeBatteries.front();
    //CStaticBattery* current = 0;

    //_INFO << "START \r\n";
    while(nextBattery){

        TTrackedBatteries::const_iterator it = std::find( trackedBatteries.begin(), trackedBatteries.end(), nextBattery );

        // if battery not already tracked
        if(it == trackedBatteries.end() ){

            return nextBattery;
        }


        nextBattery = nextBattery->_next;

    }*/

    return 0;
}









//
//void
//IFleetForwardListBased::clearDeadPool()
//{
//
////    for( : )
//    BOOST_FOREACH(auto& pool, _deadPool){
//
//        pool.clear();
//    }
//
//    //std::for_each()
//}
//



//    std::vector<int> test;
//    test.push_back(4);
//    test.push_back(5);
//    test.push_back(8);
//    for(int i : test){
//        _INFO << "Range based for loop int: " <<  i;
//    }


//template<class T,class PARAM>
//void loopThroughBatteries( std::forward_list<PARAM>& container, T* instance, bool (T::*fn)(PARAM)  )
//{
//
//    FUS_ASSERT(fn != nullptr && "");
//
//    auto beginBattery( container.begin() );
//    auto beforeCurrentBatteryIt( container.before_begin());
//    auto lastBattery( container.end() );
//
//    auto currentBatteryIt = beginBattery;
//
//    while( currentBatteryIt != lastBattery )
//    {
//        //! quand retourne vraie on supprime
//        if( (instance->*fn)( *currentBatteryIt )  ){
//
//            currentBatteryIt = container.erase_after( beforeCurrentBatteryIt );
//        }
//        else {
//            beforeCurrentBatteryIt = currentBatteryIt;
//            currentBatteryIt++;
//        }
//    }
//}

bool
IFleetForwardListBased::sporadicBatteryCheck( IStaticBattery* battery )
{

    bool stillOffscreen = getPlayState()->isEntityOufOfScreen(battery);
    battery->stillOutOfScreen( stillOffscreen );

    if( battery->getOffscreenCounter() > 3 )
    {

        battery->onTimeoutDisparition();

        //! add battery to cache
        cacheBattery(battery);
//        getPlayState()->onTimeoutDisparition(battery);
        _INFO << "timed out death ";
        return true;
    }

    return false;
}

void
IFleetForwardListBased::sporadicCheck()
{
//    battery->outOfScreenTimeout()

    _INFO << "Periodic check called";



//    loopThroughBatteries( _activeBatteries, this, &IFleetForwardListBased::periodicCheck);
//    std::remove_if()
    _activeBatteries.remove_if( std::bind1st( std::mem_fun(&IFleetForwardListBased::sporadicBatteryCheck),this) );

    // remove_if out of screen
    _INFO << "Periodic check call finished";
}



void
IFleetForwardListBased::cacheBattery(IStaticBattery* battery )
{
    const EEntityType::EId type = battery->getType();
    _deadPool[ type ].push_front(battery);

// TODO
//    battery->_node->setParent( getCachedFleetNode() );

    // TODO should change its parent so that it doesn't get displayed
//    battery->getNode()
//    battery->onGettingCached();
}




//CGameEngine::getAudioManager()->Play("sounds/explosion.wav");
//            CSound* sound = new CSound("sounds/explosion.wav");
//            sound->play();
//state->shakeCamera();


bool
IFleetForwardListBased::regularBatteryUpdate(const TTimer::TimeType& elapsedTime , IStaticBattery* battery)
{
    battery->update(elapsedTime);

    // We should check out of screen at some interval,
    // not every frame todo
//        consumingUpdate( IStaticBattery* );

//    if(type == EEntityType::Player )
//    {
//        _INFO << "killing player";
//        dynamic_cast<CPlayer*>(battery)->kill();
//

    // check conditions of death
    if( battery->getRemainingLife() < 0 )
    {


        //cache_after( beforeCurrentBatteryIt , battery);
        getPlayState()->onBatteryDeath( battery );

        cacheBattery(battery);
        //! add it to the cache

        _INFO << "onDeath : battery damage > 0 => EXPLOSION";

        //! we don't want to remove the player from
        return (battery->getType() != EEntityType::Player);
    }

    return false;
}



// shouldbe elapsedTime .
void
IFleetForwardListBased::update(const TTimer::TimeType& elapsedTime)
{

//    // TODO launch periodic check when needed
//    TBatteryContainer


    //bool erasePreviousBattery = false;

    // runs from the end to the beginning

    IFleet::update(elapsedTime);

//std::mem_fun()
//va creer un std::function
//std::placeholders;
    auto f = std::bind( &IFleetForwardListBased::regularBatteryUpdate, this , elapsedTime, std::placeholders::_1) ;
//    _activeBatteries.remove_if ( std::bind( std::mem_fun(&IFleetForwardListBased::regularBatteryUpdate), this , elapsedTime)   );
    _activeBatteries.remove_if (  f );

//    auto beginBattery( _activeBatteries.begin() );
//    auto beforeCurrentBatteryIt( _activeBatteries.before_begin());
//    auto lastBattery( _activeBatteries.end() );
//
//    auto currentBatteryIt = beginBattery;
//
//    for( ;currentBatteryIt != lastBattery; ++currentBatteryIt )
//    {
//
//        auto battery = *currentBatteryIt;
//        battery->update(elapsedTime);
//
//        // We should check out of screen at some interval,
//        // not every frame todo
////        consumingUpdate( IStaticBattery* );
//
//        // check conditions of death
//        if( battery->getRemainingLife() < 0 )
//        {
//            cache_after( beforeCurrentBatteryIt , battery);
//            getPlayState()->onBatteryDeath( battery );
//
//            _INFO << "onDeath : battery damage > 0 => EXPLOSION";
//        }
//
//        beforeCurrentBatteryIt = currentBatteryIt;
//    }


    //_INFO << "END \r\n";
}


//
//void
////IFleetForwardListBased::killEntityNextTo(CStaticBattery* battery) {
//IFleetForwardListBased::killBattery(TBatteryContainer::iterator& it)
////IFleetForwardListBased::killBattery(IStaticBattery* battery)
//{
//
//    //BOOST_ASSERT(battery != 0);
//
////    CStaticBattery* previous = battery->_previous;
//    IStaticBattery* battery = *it;
//
//    const EEntityType::EId type = battery->getType();
//
//    if(type == EEntityType::Player )
//    {
//
//        dynamic_cast<CPlayer*>(battery)->kill();
//        _INFO << "killing player";
//    }
//    else
//    {
//
//
//        _activeBatteries.erase_after(it);
//        _deadPool[ type ].push_front(battery);
//
//        // If static battery then
//        if( type == EEntityType::Battery)
//        {
//            // call lua function
//
//            //lua_State* L = ;
//            try
//            {
//
//                _INFO << "Killing static battery [" << battery << "]";
//                //luabind::call_function<void>( _fightingState->_script->getVM(), "killBattery", battery);
//            }
//            catch(std::exception& e)
//            {
//                //appellà manager:Killtask()
//                //_LOG_ERROR << "call_function from C++ launched an exception" << e.what();
//                std::string errorMsg;
//                //if(!_fightingState->_script->retrieveStringFromStack(errorMsg)){
////                    errorMsg = "No string on top of stack";
////                }
//
//               // _fightingState->engine().popupMessage(L"call_function => error " , errorMsg );
//            }
//        }
//    }
//
//
//
//}




// TODO  passer un shared_ptr ? ne rien renvoyer
#if 0
bool
IFleetForwardListBased::checkCollisions(IFleetForwardListBased* fleet)
{

    //BOOST_ASSERT(fleet != 0);



    auto ally = _activeBatteries.begin();
    auto lastAlly  = _activeBatteries.end();

    // foreach unit from this fleet
    for( ;ally != lastAlly ; ++ally)
    {

        auto enemy = fleet->_activeBatteries.begin();
        auto lastEnemy = fleet->_activeBatteries.end();

        // foreach unit from adverse fleet
        for(;enemy != lastEnemy; ++ enemy)
        {

            // if both collide
            if( (*enemy)->checkCollision(*ally) )
//            if( checkCollision( *ally, *enemy) )
            {

                // TODO renommer en ...With
                //_INFO << "collision >> enemy damage before collision [" << enemy->getDamage() << "]";
                onCollision(*ally, *enemy);

//                (*enemy)->onCollision( *ally );
//                (*ally)->onCollision( *enemy );

                //_INFO << "enemy damage after collision [" << enemy->getDamage() << "]";
                return true;
            }

            //enemy = enemy->_next;
        }
        //ally = ally->_next;
    }

/*
    CStaticBattery* ally = front();
    // foreach unit from this fleet
    while(ally){

        CStaticBattery* enemy = fleet.front();

        // foreach unit from adverse fleet
        while(enemy){

            // if both collide
            if( enemy->checkCollision(ally) ){

                // TODO renommer en ...With
                //_INFO << "collision >> enemy damage before collision [" << enemy->getDamage() << "]";

                enemy->onCollision( ally );
                ally->onCollision( enemy );

                //_INFO << "enemy damage after collision [" << enemy->getDamage() << "]";
                return true;
            }

            enemy = enemy->_next;
        }
        ally = ally->_next;
    }
*/
    return false;
}

#undef LOOP_THROUGH_BATTERIES

#endif
